package com.poject.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.poject.dto.NameInfoDto;
import com.poject.entity.NameInfoEntity;
import com.poject.mapper.NameInfoMapper;
import com.poject.service.NameInfoService;
import com.poject.vo.NameInfoVo;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @description:
 * @author: fufanrui
 * @time: 2025/1/15 13:29
 */
@Service
@RequiredArgsConstructor
public class NameInfoServiceImpl extends ServiceImpl<NameInfoMapper, NameInfoEntity>implements NameInfoService {

    private final NameInfoMapper nameInfoMapper;
    @Override
    public List<NameInfoVo> list(NameInfoDto dto) {
        LambdaQueryWrapper<NameInfoEntity> wrapper
                = new LambdaQueryWrapper<>();
        if(dto.getName()!=null && !"".equals(dto.getName())){
            wrapper.eq(NameInfoEntity::getName,dto.getName());
        }
        if(dto.getPhone()!=null && !"".equals(dto.getPhone())){
            wrapper.eq(NameInfoEntity::getPhone,dto.getPhone());
        }
        List<NameInfoEntity> nameInfoList = nameInfoMapper.selectList(wrapper);
        return nameInfoList.stream()
                .map(this::convertToVo)
                .collect(Collectors.toList());
    }
    private NameInfoVo convertToVo(NameInfoEntity entity){
        return new NameInfoVo(
                entity.getId(),
                entity.getName(),
                entity.getSex(),
                entity.getAge(),
                entity.getPhone(),
                entity.getCreateDate(),
                entity.getUpdateDate(),
                entity.getDelFlg()
        );
    }
}
